(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@s-libs/micro-dash'), require('@angular/common/http/testing'), require('@angular/core'), require('@angular/core/testing'), require('@s-libs/js-core'), require('@angular/cdk/testing'), require('@angular/cdk/testing/testbed'), require('@angular/platform-browser/animations'), require('rxjs/testing'), require('@angular/compiler'), require('@angular/platform-browser-dynamic/testing')) :
    typeof define === 'function' && define.amd ? define('@s-libs/ng-dev', ['exports', '@s-libs/micro-dash', '@angular/common/http/testing', '@angular/core', '@angular/core/testing', '@s-libs/js-core', '@angular/cdk/testing', '@angular/cdk/testing/testbed', '@angular/platform-browser/animations', 'rxjs/testing', '@angular/compiler', '@angular/platform-browser-dynamic/testing'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['s-libs'] = global['s-libs'] || {}, global['s-libs']['ng-dev'] = {}), global.microDash, global.ng.common.http.testing, global.ng.core, global.ng.core.testing, global.jsCore, global.ng.cdk.testing, global.ng.cdk.testing.testbed, global.ng.platformBrowser.animations, global.rxjs.testing, global.ng.compiler, global.ng.platformBrowserDynamic.testing));
}(this, (function (exports, microDash, testing$2, core, testing, jsCore, testing$1, testbed, animations, testing$3, compiler, testing$4) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // adapted from https://github.com/ngneat/spectator/blob/e13c9554778bdb179dfc7235aedb4b3b90302850/projects/spectator/src/lib/mock.ts
    /**
     * Creates a new object with jasmine spies for each method in `type`.
     *
     * ```ts
     * class Greeter {
     *   greet(name: string) {
     *     return `Hello, ${name}!`;
     *   }
     * }
     *
     * const spyObject = createSpyObject(Greeter);
     * spyObject.greet.and.returnValue("Hello, stub!");
     * expect(spyObject.greet("Eric")).toBe("Hello, stub!");
     * expectSingleCallAndReset(spyObject.greet, "Eric");
     * ```
     */
    function createSpyObject(type) {
        var e_1, _a;
        var mock = {};
        for (var proto = type.prototype; proto; proto = Object.getPrototypeOf(proto)) {
            try {
                for (var _b = (e_1 = void 0, __values(microDash.functions(proto))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var key = _c.value;
                    mock[key] = jasmine.createSpy(key);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return mock;
    }

    /**
     * Expects the spy to have been called the exact number of times as the argument lists provided, with those arguments, then resets the spy.
     *
     * ```ts
     * const spy = jasmine.createSpy();
     *
     * spy(1)
     * spy(2, 3)
     * spy()
     * expectCallsAndReset(spy, [1], [2, 3], []);
     * ```
     */
    function expectCallsAndReset(spy) {
        var allArgs = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            allArgs[_i - 1] = arguments[_i];
        }
        expect(spy).toHaveBeenCalledTimes(allArgs.length);
        expect(spy.calls.allArgs()).toEqual(allArgs);
        spy.calls.reset();
    }

    /**
     * Expects exactly one call to have been made to a jasmine spy, for it to have received the given arguments, then resets the spy.
     *
     * ```ts
     * const spy = jasmine.createSpy();
     *
     * spy(1, 2);
     * expectSingleCallAndReset(spy, 1, 2); // pass
     * expectSingleCallAndReset(spy, 1, 2); // fail
     *
     * spy(3);
     * spy(4);
     * expectSingleCallAndReset(spy, 3); // fail
     * ```
     */
    function expectSingleCallAndReset(spy) {
        var _a;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        expect(spy).toHaveBeenCalledTimes(1);
        (_a = expect(spy)).toHaveBeenCalledWith.apply(_a, __spread(params));
        spy.calls.reset();
    }

    /** @hidden */
    var proxyTarget = Symbol('proxy target'); // trick from https://stackoverflow.com/a/53431924/1836506
    /** @hidden */
    function synchronize(obj) {
        return new Proxy(obj, {
            get: function (target, p, receiver) {
                if (p === proxyTarget) {
                    return obj;
                }
                else {
                    return synchronizeAny(Reflect.get(target, p, receiver));
                }
            },
            apply: function (target, thisArg, argArray) {
                thisArg = microDash.get(thisArg, [proxyTarget], thisArg);
                return synchronizeAny(Reflect.apply(target, thisArg, argArray));
            },
        });
    }
    /** @hidden */
    function synchronizeAny(value) {
        if (jsCore.isPromiseLike(value)) {
            return synchronizePromise(value);
        }
        else if (microDash.isObject(value)) {
            return synchronize(value);
        }
        else {
            return value;
        }
    }
    /** @hidden */
    function synchronizePromise(promise) {
        var awaited;
        promise.then(function (value) { return (awaited = value); });
        testing.tick();
        // TODO: a nice error if the promise didn't resolve
        return synchronizeAny(awaited);
    }

    /** @hidden */
    var FakeAsyncHarnessEnvironment = /** @class */ (function (_super) {
        __extends(FakeAsyncHarnessEnvironment, _super);
        function FakeAsyncHarnessEnvironment(rawRootElement, ctx) {
            var _this = _super.call(this, rawRootElement) || this;
            _this.ctx = ctx;
            return _this;
        }
        FakeAsyncHarnessEnvironment.documentRootLoader = function (ctx) {
            return synchronize(new FakeAsyncHarnessEnvironment(document.body, ctx));
        };
        FakeAsyncHarnessEnvironment.prototype.waitForTasksOutsideAngular = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    testing.flush();
                    return [2 /*return*/];
                });
            });
        };
        FakeAsyncHarnessEnvironment.prototype.forceStabilize = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.ctx.tick();
                    return [2 /*return*/];
                });
            });
        };
        FakeAsyncHarnessEnvironment.prototype.createEnvironment = function (element) {
            return new FakeAsyncHarnessEnvironment(element, this.ctx);
        };
        FakeAsyncHarnessEnvironment.prototype.createTestElement = function (element) {
            return new testbed.UnitTestElement(element, microDash.bindKey(this, 'forceStabilize'));
        };
        FakeAsyncHarnessEnvironment.prototype.getAllRawElements = function (selector) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, Array.from(this.rawRootElement.querySelectorAll(selector))];
                });
            });
        };
        FakeAsyncHarnessEnvironment.prototype.getDocumentRoot = function () {
            return document.body;
        };
        return FakeAsyncHarnessEnvironment;
    }(testing$1.HarnessEnvironment));

    /** @hidden */
    function extendMetadata(metadata, toAdd) {
        var result = microDash.clone(metadata);
        microDash.forOwn(toAdd, function (val, key) {
            result[key] = Array.isArray(result[key]) ? result[key].concat(val) : val;
        });
        return result;
    }
    /**
     * Provides the foundation for an opinionated testing pattern.
     * - All test are run in the `fakeAsync` zone. This gives you full control over
     *   the timing of everything by default.
     * - Variables that are initialized for each test exist in a context that is
     *   thrown away, so they cannot leak between tests.
     * - Clearly separates initialization code from the test itself.
     * - Gives control over the simulated date & time with a single line of code.
     * - Always verifies no un-expected http requests were made during a test.
     * - Always discards periodic tasks at the end of each test to automatically
     *   avoid an error from the `fakeAsync` zone.
     *
     * This example tests a simple service that uses HttpClient, and is tested by
     * using `AngularContext` directly. More often `AngularContext` will be used a
     * super class. See {@link ComponentContext} for more common use cases.
     * ```ts
     *  // This is the class we will test.
     *  @Injectable({ providedIn: 'root' })
     *  class MemoriesService {
     *   constructor(private httpClient: HttpClient) {}
     *
     *   getLastYearToday(): Observable<any> {
     *     const datetime = new Date();
     *     datetime.setFullYear(datetime.getFullYear() - 1);
     *     const date = datetime.toISOString().split('T')[0];
     *     return this.httpClient.get(`http://example.com/post-from/${date}`);
     *   }
     * }
     *
     *  describe('MemoriesService', () => {
     *
     *   // Tests should have exactly 1 variable outside an "it": `ctx`.
     *   let ctx: AngularContext;
     *   beforeEach(() => {
     *     ctx = new AngularContext();
     *   });
     *
     *   it('requests a post from 1 year ago', () => {
     *
     *     // Before calling `run`, set up any context variables this test needs.
     *     ctx.startTime = new Date('2004-02-16T10:15:00.000Z');
     *
     *     // Pass the test itself as a callback to `run()`.
     *     ctx.run(() => {
     *       const httpBackend = ctx.inject(HttpTestingController);
     *       const myService = ctx.inject(MemoriesService);
     *
     *       myService.getLastYearToday().subscribe();
     *
     *       httpBackend.expectOne('http://example.com/post-from/2003-02-16');
     *     });
     *   });
     * });
     * ```
     */
    var AngularContext = /** @class */ (function () {
        /**
         * @param moduleMetadata passed along to [TestBed.configureTestingModule()]{@linkcode https://angular.io/api/core/testing/TestBed#configureTestingModule}. Automatically includes {@link HttpClientTestingModule} for you.
         */
        function AngularContext(moduleMetadata) {
            if (moduleMetadata === void 0) { moduleMetadata = {}; }
            /**
             * Set this before calling `run()` to mock the time at which the test starts.
             */
            this.startTime = new Date();
            this.loader = FakeAsyncHarnessEnvironment.documentRootLoader(this);
            testing.TestBed.configureTestingModule(extendMetadata(moduleMetadata, { imports: [testing$2.HttpClientTestingModule] }));
        }
        AngularContext.prototype.run = function (optionsOrTest, test) {
            var _this = this;
            var options = {};
            if (microDash.isFunction(optionsOrTest)) {
                test = optionsOrTest;
            }
            else {
                options = optionsOrTest;
            }
            jasmine.clock().install();
            testing.fakeAsync(function () {
                jasmine.clock().mockDate(_this.startTime);
                jsCore.assert(test);
                _this.init(options);
                try {
                    test();
                    _this.verifyPostTestConditions();
                }
                finally {
                    _this.cleanUp();
                }
            })();
            jasmine.clock().uninstall();
        };
        /**
         * Gets a service or other injectable from the root injector. This implementation is a simple pass-through to [TestBed.inject()]{@linkcode https://angular.io/api/core/testing/TestBed#inject}, but subclasses may provide their own implementation. It is recommended to use this in your tests instead of using `TestBed` directly.
         */
        AngularContext.prototype.inject = function (token) {
            return testing.TestBed.inject(token);
        };
        /**
         * Gets a component harness, wrapped for use in a fakeAsync test so that you do not need to `await` its results. Throws an error if no match can be located.
         */
        AngularContext.prototype.getHarness = function (query) {
            return this.loader.getHarness(query);
        };
        /**
         * Gets a component harness, wrapped for use in a fakeAsync test so that you do not need to `await` its results. Returns `null` if the harness cannot be located.
         */
        AngularContext.prototype.getHarnessForOptional = function (query) {
            return this.loader.locatorForOptional(query)();
        };
        /**
         * Gets all component harnesses that match the query, wrapped for use in a fakeAsync test so that you do not need to `await` its results.
         */
        AngularContext.prototype.getAllHarnesses = function (query) {
            return this.loader.getAllHarnesses(query);
        };
        /**
         * Advance time and trigger change detection. It is common to call this with no arguments to trigger change detection without advancing time.
         *
         * @param unit The unit of time `amount` represents. Accepts anything described in `@s-libs/s-core`'s [TimeUnit]{@linkcode https://simontonsoftware.github.io/s-js-utils/typedoc/enums/timeunit.html} enum.
         */
        AngularContext.prototype.tick = function (amount, unit) {
            if (amount === void 0) { amount = 0; }
            if (unit === void 0) { unit = 'ms'; }
            // To simulate real life, trigger change detection before processing macro tasks. To further simulate real life, wait until the micro task queue is empty.
            testing.flushMicrotasks();
            this.runChangeDetection();
            testing.tick(jsCore.convertTime(amount, unit, 'ms'));
        };
        /**
         * This is a hook for subclasses to override. It is called during `run()`, before the `test()` callback. This implementation does nothing, but if you override this it is still recommended to call `super.init(options)` in case this implementation does something in the future.
         */
        AngularContext.prototype.init = function (_options) { };
        /** @hidden */
        AngularContext.prototype.runChangeDetection = function () {
            this.inject(core.ApplicationRef).tick();
        };
        /**
         * Runs post-test verifications. This base implementation runs [HttpTestingController#verify]{@linkcode https://angular.io/api/common/http/testing/HttpTestingController#verify}. Unlike {@link #cleanUp}, it is OK for this method to throw an error to indicate a violation.
         */
        AngularContext.prototype.verifyPostTestConditions = function () {
            this.inject(testing$2.HttpTestingController).verify();
        };
        /**
         * Performs any cleanup needed at the end of each test. This base implementation calls [discardPeriodicTasks]{@linkcode https://angular.io/api/core/testing/discardPeriodicTasks} to avoid an error from the `fakeAsync` zone.
         */
        AngularContext.prototype.cleanUp = function () {
            testing.discardPeriodicTasks();
        };
        return AngularContext;
    }());

    /** @hidden */
    var initialStyles;
    /**
     * When called at the right times, this speeds up your test suite by removing `<script>` tags that Angular component tests leave in the DOM. By default Angular dynamically adds `<script>` tags into the `<head>` of the document corresponding to component styles. In Jasmine tests they are never cleaned up. This can cause hundreds or even thousands of style tags to accumulate, making component tests slow down as your test suite runs. In Chrome debugger's performance tab, this time will show up under the activity "Recalculate Style".
     *
     * The first time this function is called it memorizes the `<script>` tags in the DOM, then each time it is called after it removes any that appeared since. A simple way to use this effectively is to call it in a `beforeEach()`.
     *
     * ```ts
     * beforeEach(() => {
     *   trimLeftoverStyles();
     * });
     * ```
     */
    function trimLeftoverStyles() {
        var e_1, _a;
        var styles = new Set(Array.from(document.querySelectorAll('style')));
        if (initialStyles) {
            try {
                for (var styles_1 = __values(styles), styles_1_1 = styles_1.next(); !styles_1_1.done; styles_1_1 = styles_1.next()) {
                    var style = styles_1_1.value;
                    if (!initialStyles.has(style)) {
                        style.remove();
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (styles_1_1 && !styles_1_1.done && (_a = styles_1.return)) _a.call(styles_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            initialStyles = styles;
        }
    }
    /** @hidden */
    function resetTrimLeftoverStyles() {
        initialStyles = undefined;
    }

    /**
     * A superclass to set up testing contexts for components. This is a foundation for an opinionated testing pattern, including everything described in {@link AngularContext}. A very simple example:
     *
     * ```ts
     * @Component({ template: 'Hello, {{name}}!' })
     * class GreeterComponent {
     *   @Input() name!: string;
     * }
     *
     * class GreeterComponentContext extends ComponentContext {
     *   protected componentType = GreeterComponent;
     * }
     *
     * describe('ComponentContext', () => {
     *   let ctx: GreeterComponentContext;
     *   beforeEach(() => {
     *     ctx = new GreeterComponentContext();
     *   });
     *
     *   it('greets you by name', () => {
     *     ctx.run({ input: { name: 'World' } }, () => {
     *       expect(ctx.fixture.nativeElement.textContent).toBe('Hello, World!');
     *     });
     *   });
     * })
     * ```
     *
     * This class integrates {@link trimLeftoverStyles} to speed up your test suite, as described in the docs for that function.
     */
    var ComponentContext = /** @class */ (function (_super) {
        __extends(ComponentContext, _super);
        /**
         * @param moduleMetadata passed along to [TestBed.configureTestingModule()]{@linkcode https://angular.io/api/core/testing/TestBed#configureTestingModule}. Automatically includes {@link NoopAnimationsModule} and {@link HttpClientTestingModule} for you.
         */
        function ComponentContext(moduleMetadata) {
            if (moduleMetadata === void 0) { moduleMetadata = {}; }
            return _super.call(this, extendMetadata(moduleMetadata, { imports: [animations.NoopAnimationsModule] })) || this;
        }
        /**
         * Constructs and initializes your component. Called during `.run()` before it executes the rest of your test. Runs in the same `fakeAsync` zone as the rest of your test.
         */
        ComponentContext.prototype.init = function (options) {
            trimLeftoverStyles();
            _super.prototype.init.call(this, options);
            this.fixture = testing.TestBed.createComponent(this.componentType);
            Object.assign(this.fixture.componentInstance, options.input);
            this.fixture.detectChanges();
            this.tick();
        };
        /** @hidden */
        ComponentContext.prototype.runChangeDetection = function () {
            this.fixture.detectChanges();
        };
        /**
         * Performs any cleanup needed at the end of each test. This implementation destroys {@link fixture} and calls the super implementation.
         */
        ComponentContext.prototype.cleanUp = function () {
            this.fixture.destroy();
            _super.prototype.cleanUp.call(this);
        };
        return ComponentContext;
    }(AngularContext));

    /**
     * Designed for temporary use when a test using `fakeAsync` is giving you "Error: X timer(s) still in the queue", and you don't know what they are. Call this at the top of the test to see everything that adds a timer printed to the JS console. In Chrome you can click the function in the console output to be taken directly to its definition in the Sources tab.
     *
     * Be sure to call this _inside_ the test, not before, to get the most useful output.
     *
     * @returns a function to stop the logging
     *
     * ```ts
     * it('definitely does not set any timeouts', fakeAsync(() => {
     *   const stopLogging = logTimers();
     *
     *   doTheRestOfMyTest();
     *
     *   stopLogging();
     * }));
     * ```
     */
    function logTimers() {
        var restoreTimeouts = jsCore.wrapMethod(window, 'setTimeout', {
            before: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spread(['setTimeout('], args, [')']));
            },
        });
        var restoreIntervals = jsCore.wrapMethod(window, 'setInterval', {
            before: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spread(['setInterval('], args, [')']));
            },
        });
        return function () {
            restoreTimeouts();
            restoreIntervals();
        };
    }

    /**
     * A helper to take some boilerplate out of RxJS's new marble testing API for jasmine.
     *
     * ```ts
     * it("doubles numbers", marbleTest(({ cold, expectObservable }) => {
     *   const source = cold("-1-2-3-|");
     *   const expected = "   -2-4-6-|");
     *   expectObservable(source.pipe(double())).toBe(expected);
     * }));
     * ```
     */
    function marbleTest(callback) {
        var testScheduler = new testing$3.TestScheduler(function (actual, expected) {
            expect(actual).toEqual(expected);
        });
        return function () { return testScheduler.run(function (helpers) { return callback(Object.assign(Object.assign({}, helpers), { testScheduler: testScheduler })); }); };
    }

    /**
     * Use this to speed up your angular test suite. Normally when you call `TestBed.compileComponents()`, it recompiles all the configured components even if it has compiled them before in a previous test. AoT compilation would be a great fix, but is not well supported/documented for tests yet. This function fills the gap by precompiling the components as if by AoT and setting up `TestBed` to use them.
     *
     * ```ts
     * // let's assume `AppModule` declares or imports a `HelloWorldComponent`
     * precompileForTests([AppModule]);
     *
     * // Everything below here is the same as normal. Just add the line above.
     *
     * describe("AppComponent", () => {
     *   it("says hello", async () => {
     *     TestBed.configureTestingModule({ declarations: [HelloWorldComponent] });
     *     await TestBed.compileComponents(); // <- this line is faster
     *     const fixture = TestBed.createComponent(HelloWorldComponent);
     *     expect(fixture.nativeElement.textContent).toContain("Hello, world!");
     *   });
     * });
     * ```
     *
     * Note that this uses `TestBed.initTestEnvironment` to set up the precompiled components, so you will not be able to use it yourself at the same time.
     *
     * @deprecated This is no longer needed with Ivy.
     */
    function precompileForTests(modules, skipModules) {
        var _this = this;
        if (skipModules === void 0) { skipModules = []; }
        beforeAll(function () { return __awaiter(_this, void 0, void 0, function () {
            var metadataResolver;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        metadataResolver = optionallyInject(compiler.CompileMetadataResolver);
                        if (!metadataResolver) {
                            console.warn("precompileForTests() is no longer needed with Ivy. Skipping.");
                            return [2 /*return*/];
                        }
                        testing.TestBed.configureTestingModule({ imports: modules });
                        return [4 /*yield*/, testing.TestBed.compileComponents()];
                    case 1:
                        _a.sent();
                        testing.TestBed.resetTestEnvironment();
                        testing.TestBed.initTestEnvironment(testing$4.BrowserDynamicTestingModule, testing$4.platformBrowserDynamicTesting(), function () { return extractAotSummaries(metadataResolver, modules, new Set(skipModules)); });
                        return [2 /*return*/];
                }
            });
        }); });
    }
    // TODO: this could be a public function
    /** @hidden */
    function optionallyInject(token) {
        return testing.TestBed.inject(token, null, core.InjectFlags.Optional);
    }
    /** @hidden */
    function extractAotSummaries(metadataResolver, modules, skipModules) {
        return modules.map(function (module) { return function () { return extractAotSummaries0(metadataResolver, module, skipModules); }; });
    }
    /** @hidden */
    function extractAotSummaries0(metadataResolver, module, skipModules) {
        if (skipModules.has(module)) {
            return [];
        }
        skipModules.add(module);
        var moduleMetadata = metadataResolver.getNgModuleMetadata(module);
        return [
            metadataResolver.getNgModuleSummary(module),
            function () { return extractDirectives(moduleMetadata, metadataResolver); },
            function () { return extractPipes(moduleMetadata, metadataResolver); },
            function () { return extractAotSummaries(metadataResolver, extractImports(moduleMetadata), skipModules); },
        ];
    }
    /** @hidden */
    function extractDirectives(moduleMetadata, metadataResolver) {
        return moduleMetadata.declaredDirectives.map(function (directive) { return metadataResolver.getDirectiveSummary(directive.reference); });
    }
    /** @hidden */
    function extractPipes(moduleMetadata, metadataResolver) {
        return moduleMetadata.declaredPipes.map(function (pipe) { return metadataResolver.getPipeSummary(pipe.reference); });
    }
    /** @hidden */
    function extractImports(moduleMetadata) {
        return moduleMetadata.importedModules.map(function (importedModule) { return importedModule.type.reference; });
    }

    /*
     * Public API Surface of ng-dev
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularContext = AngularContext;
    exports.ComponentContext = ComponentContext;
    exports.createSpyObject = createSpyObject;
    exports.expectCallsAndReset = expectCallsAndReset;
    exports.expectSingleCallAndReset = expectSingleCallAndReset;
    exports.logTimers = logTimers;
    exports.marbleTest = marbleTest;
    exports.precompileForTests = precompileForTests;
    exports.trimLeftoverStyles = trimLeftoverStyles;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=s-libs-ng-dev.umd.js.map
