import { HarnessEnvironment } from '@angular/cdk/testing';
import { UnitTestElement } from '@angular/cdk/testing/testbed';
import { AngularContext } from './angular-context';
import { Synchronized } from './synchronize';
/** @hidden */
export declare class FakeAsyncHarnessEnvironment extends HarnessEnvironment<Element> {
    private ctx;
    static documentRootLoader(ctx: AngularContext): Synchronized<FakeAsyncHarnessEnvironment>;
    protected constructor(rawRootElement: Element, ctx: AngularContext);
    waitForTasksOutsideAngular(): Promise<void>;
    forceStabilize(): Promise<void>;
    protected createEnvironment(element: Element): HarnessEnvironment<Element>;
    protected createTestElement(element: Element): UnitTestElement;
    protected getAllRawElements(selector: string): Promise<Element[]>;
    protected getDocumentRoot(): Element;
}
